/**
 * Title :        XLogo
 * Description :  XLogo is an interpreter for the Logo 
 * 						programming language
 * @author Loïc Le Coq
 */
package xlogo.kernel;
import java.util.Stack;
import java.util.StringTokenizer;
import xlogo.utils.Utils;
public class Procedure {
  public boolean affichable; // false lorsque c'est une procédure d'un fichier de démarrage
  public int nbparametre;
  public String name;
  public Stack variable=new Stack();
  private int id;
  public String instruction="";
  public String instr=null;
  public String instruction_sauve="";  // En cas de mauvaise écriture dans l'éditeur
public 	String instr_sauve=null;		  // Permet de revenir aux valeurs antérieures d'une 
public 	Stack variable_sauve=new Stack(); // procédure avant modification
  public Procedure() {
  }
  public Procedure(String name,int nbparametre,Stack variable,int id,boolean affichable){
    this.name=name;
    this.nbparametre=nbparametre;
    this.variable=variable;
    this.id=id;
    this.affichable=affichable;
  }
  public void decoupe(){
  	if (null==instr){
  		String tex=new String(Utils.decoupe(instruction));
  //		System.out.println(tex);
  		StringTokenizer texte=new StringTokenizer(tex," \n#",true);
      instr="";
      while(texte.hasMoreTokens()){
        String mot=texte.nextToken();
        while ((mot.equals(" ")||mot.equals("\n"))&&texte.hasMoreTokens())  mot=texte.nextToken();
        while (mot.equals("#")) {        // on élimine les commentaires
          while(texte.hasMoreTokens()){
            if (texte.nextToken().equals("\n")) {
							if (texte.hasMoreTokens()) mot=texte.nextToken();
							else {mot=" ";break;}
							while ((mot.equals(" ")||mot.equals("\n"))&&texte.hasMoreTokens())  mot=texte.nextToken();
							break;
						} 
          }
        }
        if ((mot.equals(" ")||mot.equals("\n"))&&!texte.hasMoreTokens()) break;
        else{
         instr+=mot+" ";
        }
      }
    }
  }
  public String toString(){
    return("nom "+name+" nombre paramètres "+nbparametre+" identifiant "+id+"\n"+variable.toString()+"\n"+instr+"\ninstrction_sauve"+instruction_sauve+"\ninstr_sauve\n"+instr_sauve);
  }
  public String getName(){
  	return (name);
  }
}